import 'package:jobportal/data/company.dart';
import 'package:jobportal/data/company_job.dart';
import 'package:jobportal/data/interview.dart';
import 'package:jobportal/data/job_interview.dart';
import 'package:jobportal/data/jobseeker.dart';
import 'package:jobportal/data/status.dart';
import '../data/cv.dart';
import '../data/identifier.dart';
import '../data/job.dart';
import '../data/job_application.dart';
import '../data/jobseeker_interview.dart';
import '../data/mynotification.dart';

class FromJson {
  static Jobseeker toJobseeker(Map<String, dynamic> json) {
    return Jobseeker(
      id: json['id'],
      specificationName: json['specificationName'],
      birthdate: DateTime.parse(json['birthdate']),
      gender: json['gender'],
      email: json['email'],
      address: json['address'],
      name: json['name'],
      phoneNumber: json['phoneNumber'],
      image: json['image'],
    );
  }

  static Interview toInterview(Map<String, dynamic> json) {
    return Interview(
      id: json['id'],
      jobseekerId: json['jobseekerId'],
      companyId: json['companyId'],
      jobId: json['jobId'],
      date: DateTime.parse(json['date']),
      address: json['address'],
      status: json['status'],
    );
  }

  static JobInterview toJobInterview(Map<String, dynamic> json) {
    return JobInterview(
      id: json['id'],
      jobseekerId: json['jobseekerId'],
      companyId: json['companyId'],
      jobId: json['jobId'],
      date: DateTime.parse(json['date']),
      address: json['address'],
      status: json['status'],
      jobseekerName: json['jobseekerName'],
      jobseekerPhoneNumber: json['jobseekerPhoneNumber'],
      jobseekerEmail: json['jobseekerEmail'],
      jobseekerImage: json['jobseekerImage'],
      jobseekerAddress: json['jobseekerAddress'],
      jobseekerGender: json['jobseekerGender'],
      jobseekerBirthdate: DateTime.parse(json['jobseekerBirthdate']),
      jobseekerSpecificationName: json['jobseekerSpecificationName'],
    );
  }

  static Identifier toIdentifier(Map<String, dynamic> json) {
    print(json.toString());
    int id;
    String token;
    bool isCompany;
    String name;
    String role;
    id = json['id'];
    token = json['jwt'];
    role = json['role'];
    name = json['userName'];
    if (role == 'Company') {
      isCompany = true;
    } else {
      isCompany = false;
    }
    return Identifier(id, token, isCompany, name);
  }

  static JobseekerInterview toJobseekerInterview(Map<String, dynamic> json) {
    print(json);
    return JobseekerInterview(
      id: json['id'],
      jobseekerId: json['jobseekerId'],
      companyId: json['companyId'],
      jobId: json['jobId'],
      date: DateTime.parse(json['date']),
      address: json['address'],
      status: json['status'],
      companyName: json['companyName'],
      companyPhoneNumber: json['companyPhoneNumber'],
      companyEmail: json['companyEmail'],
      companyImage: json['companyImage'],
      companyAddress: json['companyAddress'],
      jobName: json['jobName'],
      jobSpecificationName: json['jobSpecificationName'],
      jobTimeType: json['jobTimeType'],
    );
  }

  static JobApplication toJobApplication(Map<String, dynamic> json) {
    return JobApplication(
      applicantId: json['applicantId'],
      jobSeekerId: json['jobSeekerId'],
      jobId: json['jobId'],
    );
  }

  static Status toStatus(Map<String, dynamic> json) {
    return Status(
      status: json['status'],
      description: json['describtion'],
    );
  }

  static Job toJob(Map<String, dynamic> json) {
    return Job(
      id: json['jobId'],
      companyId: json['companyId'],
      companyName: json['companyName'],
      description: json['description'],
      name: json['name'],
      phone: json['phone'],
      email: json['email'],
      specificationName: json['specificationName'],
      timeType: json['timeType'],
      image: json['imageURL'],
      requiredLevel: json['requiredLevel'],
      minSalary: json['minSalary'],
      maxSalary: json['maxSalary'],
      experience: json['experience'],
    );
  }

  static Company toCompany(Map<String, dynamic> json) {
    return Company(
        id: json['id'],
        name: json['name'],
        phone: json['phone'],
        email: json['email'],
        image: json['image'],
        address: json['address'],
        description: json['description']);
  }

  static CV toCv(Map<String, dynamic> json) {
    return CV(
      cvId: json['cvId'] as String,
      certificates: (json['certificates'] as List<dynamic>)
          .map((certificateJson) => Certificate(
                name: certificateJson['name'] as String,
                issuingOrganization:
                    certificateJson['issuingOrganization'] as String,
                completionDate: certificateJson['completionDate'] as String,
              ))
          .toList(),
      stages: (json['stages'] as List<dynamic>)
          .map((stageJson) => Stage(
                name: stageJson['name'] as String,
                institution: stageJson['institution'] as String,
                fieldOfStudy: stageJson['fieldOfStudy'] as String,
                duration: stageJson['duration'] as String,
              ))
          .toList(),
      previousWorks: (json['previousWorks'] as List<dynamic>)
          .map((previousWorkJson) => PreviousWork(
                jobTitle: previousWorkJson['jobTitle'] as String,
                company: previousWorkJson['company'] as String,
                duration: previousWorkJson['duration'] as String,
                description: previousWorkJson['description'] as String,
              ))
          .toList(),
      languages: (json['languages'] as List<dynamic>)
          .map((languageJson) => Language(
                name: languageJson['name'] as String,
                proficiencyLevel: languageJson['proficiencyLevel'] as String,
              ))
          .toList(),
    );
  }

  static MyNotification toMyNotification(Map<String, dynamic> json) {
    return MyNotification(
        id: json['id'],
        companyId: json['companyId'],
        jobSeekerId: json['jobseekerId'],
        details: json['details'],
        date: json['createdAt'],
        jobId: json['jobId']);
  }

  static CompanyJob toCompanyJob(Map<String, dynamic> json) {
    return CompanyJob(
        id: json['jobId'],
        companyId: json['companyId'],
        companyName: json['companyName'],
        description: json['description'],
        name: json['name'],
        phone: json['phone'],
        email: json['email'],
        specificationName: json['specificationName'],
        timeType: json['timeType'],
        image: json['imageURL'],
        requiredLevel: json['requiredLevel'],
        minSalary: json['minSalary'],
        maxSalary: json['maxSalary'],
        experience: json['experience'],
        applicantsNumber: json['applicantsNumber'],
        interviewsNumber: json['interviewsNumber']);
  }
}
